/*
 * Book's Story — free and open-source Material You eBook reader.
 * Copyright (C) 2024-2026 Acclorite
 * SPDX-License-Identifier: GPL-3.0-only
 */

package org.dueattendant149.bookshelf.domain.use_case.book

import org.dueattendant149.bookshelf.core.log.logE
import org.dueattendant149.bookshelf.core.log.logI
import org.dueattendant149.bookshelf.domain.model.library.Book
import org.dueattendant149.bookshelf.domain.repository.BookRepository
import org.dueattendant149.bookshelf.domain.repository.HistoryRepository
import javax.inject.Inject

private const val TAG = "GetBook"

class GetBookUseCase @Inject constructor(
    private val bookRepository: BookRepository,
    private val historyRepository: HistoryRepository
) {

    suspend operator fun invoke(bookId: Int): Book? {
        logI(TAG, "Getting book: [$bookId].")

        bookRepository.getBook(bookId).fold(
            onSuccess = { book ->
                val history = historyRepository.getHistoryForBook(book.id).getOrNull()

                logI(TAG, "Successfully got book: [$bookId].")
                return book.copy(
                    lastOpened = history?.time
                )
            },
            onFailure = {
                logE(TAG, "Could not get book [$bookId] with error: ${it.message}")
                return null
            }
        )
    }
}